///////////////////////////////////////////////////////////////////////////////
//
// For more information, please see: http://www.nektar.info
//
// The MIT License
//
// Copyright (c) 2006 Division of Applied Mathematics, Brown University (USA),
// Department of Aeronautics, Imperial College London (UK), and Scientific
// Computing and Imaging Institute, University of Utah (USA).
//
// License for the specific language governing rights and limitations under
// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the "Software"),
// to deal in the Software without restriction, including without limitation
// the rights to use, copy, modify, merge, publish, distribute, sublicense,
// and/or sell copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included
// in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
// DEALINGS IN THE SOFTWARE.
//
///////////////////////////////////////////////////////////////////////////////

#include <LibUtilities/BasicUtils/XmlUtil.h>

namespace Nektar
{
    const char* XmlUtil::NEKTAR_ELEMENT_NAME = "NEKTAR";
    const char* XmlUtil::GEOMETRY_ELEMENT_NAME = "GEOMETRY";
    const char* XmlUtil::DIM_GEOMETRY_ATTRIBUTE = "DIM";
    const char* XmlUtil::SPACE_GEOMETRY_ATTRIBUTE = "SPACE";
    const char* XmlUtil::VERTEX_ELEMENT_NAME = "VERTEX";
    const char* XmlUtil::V_ELEMENT_NAME = "V";
    const char* XmlUtil::ID_VERTEX_ATTRIBUTE_NAME = "ID";
    const char* XmlUtil::EDGE_ELEMENT_NAME = "EDGE";
    const char* XmlUtil::E_ELEMENT_NAME = "E";
    const char* XmlUtil::CURVED_ELEMENT_NAME = "CURVED";
    const char* XmlUtil::FACE_ELEMENT_NAME = "FACE";
    const char* XmlUtil::COMPOSITE_ELEMENT_NAME = "COMPOSITE";
    const char* XmlUtil::C_ELEMENT_NAME = "C";
    const char* XmlUtil::DOMAIN_ELEMENT_NAME = "DOMAIN";
    const char* XmlUtil::ELEMENT_ELEMENT_NAME = "ELEMENT";
    const char* XmlUtil::S_ELEMENT_NAME = "S";
    const char* XmlUtil::T_ELEMENT_NAME = "T";
    const char* XmlUtil::Q_ELEMENT_NAME = "Q";
    const char* XmlUtil::A_ELEMENT_NAME = "A";
    const char* XmlUtil::P_ELEMENT_NAME = "P";
    const char* XmlUtil::R_ELEMENT_NAME = "R";
    const char* XmlUtil::H_ELEMENT_NAME = "H";
    const char* XmlUtil::PARAMETERS_ELEMENT_NAME = "PARAMETERS";
    const char* XmlUtil::SOLVERINFO_ELEMENT_NAME = "SOLVERINFO";
    const char* XmlUtil::VARIABLES_ELEMENT_NAME = "VARIABLES";
    const char* XmlUtil::BOUNDARYCONDITIONS_ELEMENT_NAME = "BOUNDARYCONDITIONS";
}


